//------------------------------------------------------------
//  jsFileName
//  simple filename functions
//  Gilles Dietrich 2015
//------------------------------------------------------------
var SEEK_SET    = 0;
var SEEK_CUR    = 1;
var SEEK_END    = 2;

function jsFileName(name)
{
    this.name = name;
}

jsFileName.prototype.GetSize = function()
{
    var size = 0;
    if (Mi.FileExists(this.name))
    {
        var file = new File(this.name, "rb");
        if (file.isOpen())
        {
            file.seek(0, SEEK_END);
            size = file.tell();
            file.close();
        }
    }
    return size;
}

jsFileName.prototype.Exists = function()
{
	return Mi.FileExists(this.name);
}

jsFileName.prototype.GetPath = function()
{
    var path = this.name;
    var sep = this.GetPathSeparator();
    path = path.substring(0,path.lastIndexOf(sep));
    if (path == "")
    {
        path = this.name;
        path = path.substring(0,path.lastIndexOf("/"));
    }
    return path;
}

jsFileName.prototype.GetFullName = function()
{
    var name = this.name;
    name =  name.split('\\').pop().split('/').pop();
    return name;
}

jsFileName.prototype.GetName = function()
{
    var name = this.name;
    name =  name.split('\\').pop().split('/').pop();
    name = name.substring(0,name.lastIndexOf("."));
    return name;
}

jsFileName.prototype.GetExt = function()
{
    var ext = this.name;
    ext = ext.split('.').pop();
    return ext;
}

jsFileName.prototype.GetPathSeparator = function()
{
    return "\\";
}

jsFileName.prototype.ClearExt = function(ext)
{
    var fullname = this.GetPath() + this.GetPathSeparator() + this.GetName();
    return fullname;
}

jsFileName.prototype.SetExt = function(ext)
{
    var fullname = this.GetPath() + this.GetPathSeparator() + this.GetName()+ "." + ext;
    return fullname;
}

jsFileName.prototype.SetName = function(name)
{
    var fullname = this.GetPath() + this.GetPathSeparator() + name + "." + this.GetExt();
    return fullname;
}

jsFileName.prototype.SetPath = function(path)
{
    var name = path + this.GetPathSeparator() + this.GetName() + "." + this.GetExt();
    return fullname;
}

jsFileName.prototype.Assign = function(fullname)
{
    this.name = fullname;
}
