/*

simple class de type fichier de configuration
type : number, boolean, string, array of strings, array of numbers

*/

function jsConfig(name, attr)
{
    this.name = name;
    if (!attr) attr = "rw";
    var path = Mi.GetUserDirectory();                           
    if (!Mi.DirExists(path))                                    
        Mi.MakeDirectory(path);                                 
    this.path = path;
    this.attr = attr;
    this.file = undefined;
}

jsConfig.prototype.Open = function()
{
    var path_name = this.path + "/" + this.name;          
    this.file = new File(path_name, this.attr); 
    return this.file.isOpen();
}

jsConfig.prototype.Close = function()
{
    if (this.file)
    {
        this.file.close();
        this.file = undefined;
    }
}

jsConfig.prototype.IsOpen = function()
{
    return this.file != undefined;
}

jsConfig.prototype.CheckValue = function(value)
{
    if (typeof(value) == "string") return true;
    if (typeof(value) == "number") return true;
    if (typeof(value) == "boolean") return true;
    return false;
}

jsConfig.prototype.Write = function(name, value)
{
    if (typeof(name) == "string" && this.file && this.CheckValue(value))
    {
        var s = name+"="+value.toString()+"="+typeof(value);
        this.file.writeLine(s);
        return true;
    }
    return false;
}

jsConfig.prototype.WriteStringArray = function(name, values)
{
    if (this.file && values)
    {
        var s = name+"="+values.toString()+"=array";
        this.file.writeLine(s);
        return true;
    }
    return false;
}

jsConfig.prototype.WriteNumberArray = function(name, values)
{
    if (this.file && values)
    {
        var s = name+"="+values.toString()+"=number_array";
        this.file.writeLine(s);
        return true;
    }
    return false;
}


jsConfig.prototype.Read = function(name, default_value)
{
    var val = default_value;
    if (typeof(name) == "string" && this.file)
    {
        this.file.rewind();
        while (!this.file.eof())                     
        {
            var line = this.file.readLine();
            if (line)
            {
                var s_line = line.split("=");       
                var param_name = name+"=";
                if (line.startsWith(param_name) && s_line.length == 3)
                {
                    var type = s_line[2];
                    var value = s_line[1];
                    if (type == "number")
                    {
                        val = Number(value);
                    }
                    else if (type == "boolean")
                    {
                        if (value == "true") val = true;
                        else val = false;
                    }
                    else if (type == "string")
                    {
                        val = value;
                    }
                    else if (type == "array")           // only string array
                    {
                        val = value.split(",");
                    }
                    else if (type == "number_array")      // only number array
                    {
                        var tmp = value.split(",");
                        val = new Array(0);
                        var i;
                        var len = tmp.length;
                        for(i = 0; i < len; i++)
                            val[i] = Number(tmp[i]);
                    }
                }
            }
        }
    }
    return val;
}

jsConfig.prototype.ReadArray = function(name, default_values)
{
    return this.Read(name, default_values);
}
/*
var ini_file = "test.ini";

var markers = ["m1", "m2"];
var numbers = [1, 2, 3, 5.5];

print(typeof(markers));
print(markers.toString());

var w_config = new jsConfig(ini_file, "w");
if (w_config.Open())
{
    print("Fichier ouvert en ecriture");
    
    var v1 = Math.PI;
    w_config.Write("V1", v1);    
    w_config.WriteStringArray("Markers", markers);    
    w_config.WriteNumberArray("Numbers", numbers);    

    w_config.Close();
}
else
{
    print("Erreur de config.");
}

var r_config = new jsConfig(ini_file, "r");
if (r_config.Open())
{
    print("Fichier ouvert en lecture");
    print("V1 = "+r_config.Read("V1"));
    print("Markers = "+r_config.Read("Markers"));
    print("Numbers = "+r_config.Read("Numbers"));    

    r_config.Close();
}
*/