//-----------------------------------------------------------------------------
// Object Excel
// Gilles Dietrich 2015
//-----------------------------------------------------------------------------
//loadlibrary("jsActiveX");

function jsExcel(show)
{
    this.XLS = undefined;
    this.XLS_app  = undefined;
    this.XLS_book  = undefined;
    this.XLS_cells  = undefined;
    this.XLS_sheet = undefined;

    this.XLS_ok = false;
    this.XLS_ok = this.Init(show);
}

jsExcel.prototype.Init = function(show)
{
    if (this.XLS_ok) return true;
    var ret = false;
    this.XLS = new ActiveXObject("Excel.Application");
    if (this.XLS.IsOk())
    {
        this.XLS_app = new ActiveXObject("Application", this.XLS);
        this.XLS_book = new ActiveXObject("WorkBooks", this.XLS);
        this.XLS_sheet = new ActiveXObject("Excel.Sheet");

        if (this.XLS_app.IsOk() && this.XLS_book.IsOk())
        {
            ret = true;
            if (show)
                this.XLS.setBooleanProperty("Visible", true);
        }
    }
    return ret;
}

jsExcel.prototype.IsOk = function()
{
    return this.XLS_ok;
}

jsExcel.prototype.Quit = function()
{
    if (this.XLS_ok)
    {
        this.XLS.callMethod("Quit");
    }
    this.XLS_ok = false;
}

jsExcel.prototype.Open = function(filename)
{
    if (this.XLS_ok)
        this.XLS_book.callMethod("Open", filename);
}

jsExcel.prototype.Save = function()
{
    if (this.XLS_ok)
        this.XLS_book.callMethod("Save");
}

jsExcel.prototype.SaveAs = function(filename)
{
    if (this.XLS_ok)
        this.XLS_book.callMethod("SaveAs", filename);
}

jsExcel.prototype.Close = function()
{
    if (this.XLS_ok)
        this.XLS_book.callMethod("Close");
}

jsExcel.prototype.OpenText = function(filename)
{
    if (this.XLS_ok)
        this.XLS_book.callMethod("OpenText", filename);
}

jsExcel.prototype.NewBook = function()
{
    if (this.XLS_ok)
        this.XLS_book.callMethod("New");
}

jsExcel.prototype.AddBook = function()
{
    if (this.XLS_ok)
        this.XLS_book.callMethod("Add");
}

jsExcel.prototype.GotoCell = function(row, col)
{
    var ret = false;
    if (this.XLS_ok)
    {
        if (!this.XLS_cells)
            this.XLS_cells = new ActiveXObject("Cells", this.XLS_app, row, col);
        if (this.XLS_cells.IsOk())
        {
            this.XLS_cells.callMethod("Activate");
        }
    }
    return ret;
}

jsExcel.prototype.GetCellValue = function(row, col)
{
    var value = undefined;
    if (this.XLS_ok)
    {
        this.GotoCell(row, col);
        if (this.XLS_cells.IsOk())
        {
            value = this.XLS_cells.getProperty("Value");
        }
    }
    return value;
}

jsExcel.prototype.SetCellValue = function(value, row, col)
{
    var ret = undefined;
    if (this.XLS_ok)
    {
        this.GotoCell(row, col);
        if (this.XLS_cells.IsOk())
        {
            ret = this.XLS_cells.setProperty("Value", value);
        }
    }
    return ret;
}

