//  file.h
//  
//  Fonctions utiles pour le traitement des noms des fichiers
//  et d'autres fonctions relatives au fichiers
//
//  Gilles Dietrich, 2014
#ifndef FILE_H
#define FILE_H

// longueur par dfaut des chaines de caractres pour les noms des fichiers
#define MAX_EXT_LEN         32
#define MAX_NAME_LEN        512
#define MAX_PATH_LEN        512
#define MAX_FULLPATH_LEN    1056

// dtermine la position de la dernire occurence de 'c' dans la chaine 'str'
int fiGetLastPos(char* str, char c);                        

// dtermine la premire de la dernire occurence de 'c' dans la chaine 'str'
int fiGetFirstPos(char* str, char c);                       

// change l'extension du nom 'in_name' avec l'extension 'ext', le rsultat est dans out_name
int fiChangeExt(char* in_name, char* ext, char* out_name);  

// renvoie l'extension (avec le '.') correspondant au nom 'full_path'
int fiGetExt(char* full_path, char* ext);

// revoie le nom (sans extension) correspondant au nom 'full_path'
int fiGetName(char* full_path, char* name);

// renvoie le rpertoire correspondant au nom 'full_path'
int fiGetPath(char* full_path, char* path);

// renvoie la lettre correspondant 'drive' du fichier 'full_path'
int fiGetDrive(char* full_path, char* drive);


// format de fichiers d'exportation
#define TRT_FORMAT      0
#define TXT_FORMAT      1
#define MAT_FORMAT      2
#define C3D_FORMAT      3
// cette fonction export un fichier de donnes au format Matlab
// si ev1 existe (et est non nul), la premire image correspond  l'vnement ev1
// si ev2 existe (et est non nul), la dernire image correspond  l'vnement ev2
// le fichier export contien une matrice pour les donnes cinmatique et 
// une matrice de donnes analogiques (si celles-ci existent)
// chaque matrice contient une premire colonne correspond au temps
// Le fichier export porte le mme nom que le fichier initial, avec une extension'.mat'
int fi_export(char* name, char* ev1, char* ev2, int format);

// renvoie le nom de la nouvelle extension en fonction du format
void fi_get_export_extension(int format, char* ext);        

#endif
