//
//  accs au donnes des marqueurs
//
#ifndef MARKER_H
#define MARKER_H

#include "mmatrix.h"

struct MMARKER
{
    struct MMATRIX  mat;                // matrice des donnes du marqueurs
    char*           name;               // nom du marqueur
    int             num;                // numro
};

// initialisation de la structure marqueur (vide)
void mkInitMarker(struct MMARKER* mkr);

// libration de la mmoire (donnes du marqueur)
void mkFreeMarker(struct MMARKER* mkr);

// renvoie true si les donnes du marqueur 'mkr' sont correctes
int mkMarkerIsOk(struct MMARKER* mkr);

// renvoie TRUE si le marqueur 'name' existe
int mkExists(char* name);

// obtient un marqueur par son numro. Renvoie TRUE en cas de succs
int mkGetMarkerFromNum(int num, struct MMARKER* mkr);

// obtient un marqueur par son nom. Renvoie TRUE en cas de succs
int mkGetMarkerFromName(char* name, struct MMARKER* mkr);

// enregsitre les donnes d'une matrice dans un autre marqueur (qui DOIT exister)
// Renvoie TRUE en cas de succs
int mkSaveDataTo(struct MMATRIX* mat, char* name);

// enregsitre les donnes du marqueur dans un autre marqueur (qui DOIT exister)
// Renvoie TRUE en cas de succs
int mkSaveMarkerTo(struct MMARKER* mkr, char* name);

// sauve les donnes du marqueur dans le fichier
// Renvoie TRUE en cas de succs
int mkSaveMarker(struct MMARKER* mkr);

int mkCreateMarker(struct MMARKER* mkr, char* name, char* unit, char* description);

int mkCheckNewMarker(struct MMARKER* mkr, char* name);
int mkCheckNewAngle(struct MMARKER* mkr, char* name);
int mkCheckNewForce(struct MMARKER* mkr, char* name);
int mkCheckNewMoment(struct MMARKER* mkr, char* name);
int mkCheckNewScalar(struct MMARKER* mkr, char* name);
int mkCheckNewPower(struct MMARKER* mkr, char* name);
int mkCheckNewReaction(struct MMARKER* mkr, char* name);

int mkDeleteMarkerFromName(char* name);
int mkDeleteMarker(struct MMARKER* mkr);

#endif