//
//  marker_set.h
//
#ifndef MARKER_SET_H
#define MARKER_SET_H

#include "mmatrix.h"
#include "marker.h"

#define SEG_MAX_MARKER  32
#define SEG_MAX_SEG     256

struct SEGMENT
{
    int     count;
    int    indexes[SEG_MAX_MARKER];
    char    name[256];
};

struct MARKER_SET
{
    char**              names;              // noms des marqueur
    int                 count;              // nombre de marqueur
    int                 seg_count;          // nombre de segments
    struct SEGMENT      segs[SEG_MAX_SEG];  // liste des segments
};

int stGetFirstValue(double invalid_value);
int stGetLastValue(double invalid_value);

void stInitMarkerSet(struct MARKER_SET* mkr_set);
void stClearMarkerSet(struct MARKER_SET* mkr_set);
void stPrintMarkerSet(struct MARKER_SET* mkr_set);
void stGetMarkerSetFromData(struct MARKER_SET* mkr_set);
void stGetMarkerSetFromFile(struct MARKER_SET* mkr_set, char* name);

int stIsInMarkerSet(struct MARKER_SET* mkr_set, char* name);

void stInitSegments(struct MARKER_SET* mkr_set, int count);
int stGetSegmentsFromFile(char* name, struct MARKER_SET* mkr_set);

#endif
