//  fichier xls.h
//  
//  Implmentation de quelques fonctions Excel utiles
//
//  Gilles Dietrich, 2014
#ifndef XLS_H
#define XLS_H

#include "ole.h"    // dfinition des constantes OLE

// Initialisation  de l'application excel 
// si 'show' = TRUE, l'application devient visible
int xlsInit(int show);

// fermeture de l'application excel
void xlsQuit();

void xlsAddBook();

void xlsNewBook();

// ouverture d'un fichier excel 'filename'
void xlsOpen(char* filename);

// ouverture d'un fichier texte 'filename'
void xlsOpenText(char* filename);

// fermeture de la feuille en cours
void xlsClose();


// remplissage de la cellule (row, col) par une chaine de caractre 'value'
int xlsSetCellString(int row, int col, char* value);

// remplissage de la cellule (row, col) par un entier 'value'
int xlsSetCellInteger(int row, int col, int value);

// remplissage de la cellule (row, col) par une valeur relle 'value'
int xlsSetCellDouble(int row, int col, double value);

// obtient la chainne de caractre de la cellule (row,col)
// value pointe sur la chiane de longueur 'size'
// renvoie TRUE en cas de succes, sinon FALSE
int xlsGetCellString(int row, int col, char* value, int size);

// obtient la valeur  (entire ou relle) de la cellule (row,col)
// value pointe sur la chiane de longueur 'size'
// renvoie TRUE en cas de succes, sinon FALSE
int xlsGetCellValue(int row, int col, double* val);

#endif
