//
//  Exemple de dll permettant de compiler des extension C
//
//  les informations sur la syntaxe PICOC se trouvent sur :
//  https://code.google.com/p/picoc/
//  addition de nouvelles fonctions : 
//  https://code.google.com/p/picoc/wiki/Adding_native_C_library_functions
// 
//  aucune dpendance avec les autres librairies picoc ne sont possibles (actuellement)  l'intrieur d'une dll
//
#include "pico_dll.h"

void CTest (struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs) 
{
    printf("test(%d)\n", Param[0]->Val->Integer);
    Param[0]->Val->Integer = 1234;
    ReturnValue->Val->Integer = 11111;
}

struct LibraryFunction test_Dll_Functions[] =
{
    { CTest,        "INT dllTest(int);" },
    { NULL,         NULL }
};

//------------------------------------------------------------------------------
//  Interface (4 fonctions OBLIGATOIRES)
//  Ces fonctions seront utilises pour enregistrer vos fonctions
//  par l'interprteur
//------------------------------------------------------------------------------
struct LibraryFunction*      GetFunctionList()
{
    return &test_Dll_Functions[0];      // adresse de la liste des fonctions
}

const char*	 GetHeaderFileName()
{
    return "test_dll.h";                // dclaration de l'entte pour inclure cette dll
}

void SetupFunc(Picoc *pc)               // si besoin d'une initialisation
{
}

// mettre ici les dfinitions de struct etc ncessaires
const char myDefs[] = "\
typedef int INT; \
";

const char*  GetDefinitions()           // adresse des dfinitions
{
    return myDefs;
}
